Attribute VB_Name = "mWhatsAppMsg"
Option Explicit
'---------------------------------------
'Module Name: mWhatsAppMsg
'Date: 19/01/2023
'Dependence: oleexp.tlb (only in design)
'Autor: Leandro Ascierto
'Web: www.leandroascierto.com
'Gratitude: Fafalone by DragDrop metods.
'Last Update: 20/09/2023
'WhatsApp version:  2.2336.7.0
'----------------------------------------
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long) ' Frees memory allocated by the shell
Private Declare Function SHDoDragDrop Lib "shell32" (ByVal hwnd As Long, ByVal pdtObj As Long, ByVal pdsrc As Long, ByVal dwEffect As Long, pdwEffect As Long) As Long
Private Declare Function ILCreateFromPathW Lib "shell32" (ByVal pwszPath As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteW" (ByVal hwnd As Long, ByVal lpOperation As Long, ByVal lpFile As Long, ByVal lpParameters As Long, ByVal lpDirectory As Long, ByVal nShowCmd As Long) As Long
Private Declare Sub keybd_event Lib "user32.dll" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
Private Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Long, ByVal dx As Long, ByVal dy As Long, ByVal cButtons As Long, ByVal dwExtraInfo As Long)
Private Declare Function GetForegroundWindow Lib "user32.dll" () As Long
Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function SetCursorPos Lib "user32.dll" (ByVal x As Long, ByVal y As Long) As Long
Private Declare Function BlockInput Lib "user32.dll" (ByVal fBlockIt As Long) As Long
Private Declare Function SetWindowPos Lib "user32.dll" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32.dll" (ByVal hwnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function SetForegroundWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ShowCursor Lib "user32.dll" (ByVal bShow As Long) As Long
Private Declare Function SetTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Function GetFocus Lib "user32.dll" () As Long
Private Declare Function GetFileAttributesW Lib "kernel32.dll" (ByVal lpFileName As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Const SWP_NOACTIVATE    As Long = &H10
Private Const SWP_SHOWWINDOW    As Long = &H40
Private Const SWP_NOMOVE        As Long = &H2
Private Const SWP_NOSIZE        As Long = &H1
Private Const HWND_TOPMOST      As Long = -1
Private Const GWL_EXSTYLE       As Long = -20
Private Const WS_EX_TRANSPARENT As Long = &H20&
Private Const WS_EX_LAYERED     As Long = &H80000
Private Const LWA_ALPHA         As Long = &H2

Private Const KEYEVENTF_KEYDOWN         As Integer = &H0
Private Const KEYEVENTF_KEYUP           As Integer = &H2
Private Const MOUSEEVENTF_LEFTDOWN As Long = &H2
Private Const MOUSEEVENTF_LEFTUP As Long = &H4


Public AnimateScreen As Form
Private m_Files As Collection
Private m_Images As Collection


Public Property Get Files() As Collection
    If m_Files Is Nothing Then Set m_Files = New Collection
    Set Files = m_Files
End Property

Public Property Set Files(NewValue As Collection)
    Set m_Files = NewValue
End Property

Public Property Get Images() As Collection
    If m_Images Is Nothing Then Set m_Images = New Collection
    Set Images = m_Images
End Property

Public Property Set Images(NewValue As Collection)
    Set m_Images = NewValue
End Property

Public Sub TimerProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal TimerID As Long, ByVal Tick As Long)
    KillTimer hwnd, TimerID
    MoveCursor
    mouse_event MOUSEEVENTF_LEFTUP, 0, 0, 0, 0
End Sub

Public Function SendMsg(ByVal PhoneNumber As String, ByVal Text As String, Optional Delay As Integer = 8000, Optional WhatsAppDesktop As Boolean = True)
    Dim i As Long
    Dim R As RECT
    Dim mHwnd As Long
    Dim T As Single

    If Len(PhoneNumber) = 0 Then
        Err.Raise 101, "Phone number is empty"
    End If

    PhoneNumber = Replace$(PhoneNumber, "+", "")
    PhoneNumber = Replace$(PhoneNumber, " ", "")
    PhoneNumber = Replace$(PhoneNumber, "-", "")

    mHwnd = Screen.ActiveForm.hwnd
     
    If Not AnimateScreen Is Nothing Then
        ShowCursor False
        SetWindowLong AnimateScreen.hwnd, GWL_EXSTYLE, GetWindowLong(AnimateScreen.hwnd, GWL_EXSTYLE) Or WS_EX_TRANSPARENT Or WS_EX_LAYERED
        SetLayeredWindowAttributes AnimateScreen.hwnd, 0, 255, LWA_ALPHA
        SetWindowPos AnimateScreen.hwnd, HWND_TOPMOST, 0, 0, Screen.Width / Screen.TwipsPerPixelX, Screen.Height / Screen.TwipsPerPixelY, SWP_NOACTIVATE Or SWP_SHOWWINDOW 'Or SWP_NOMOVE Or SWP_NOSIZE
    End If
    
    'aca es necesario que esta ventana tenga el foco
    If Not m_Files Is Nothing Then
        If m_Files.Count > 0 Then
            mouse_event MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0
        End If
    End If
    
    If WhatsAppDesktop Then
        Text = Replace(Text, "%", "%25")
        Text = Replace(Text, "&", "%26")
        Text = Replace(Text, vbCr, "%0D")
        Text = Replace(Text, vbLf, "%0A")

        If FindWindow(vbNullString, "WhatsApp") = 0 Then
            ShellExecute mHwnd, StrPtr("Open"), StrPtr("whatsapp://send?phone=" & PhoneNumber & "&text=" & Text), 0, 0, 1
            T = Timer + 10
            Do While FindWindow(vbNullString, "WhatsApp") = 0
                DoEvents
                If T < Timer Then
                    Err.Raise 102, "Can't open WhatsApp Desktop"
                    Exit Do
                End If
                
            Loop
            Sleep Delay
        End If
        
        'por si esta abierto otro chat
        ShellExecute mHwnd, StrPtr("Open"), StrPtr("whatsapp://send?phone=" & PhoneNumber & "&text=" & Text), 0, 0, 1

        Sleep 500
        ShellExecute mHwnd, StrPtr("Open"), StrPtr("whatsapp://send?phone=" & PhoneNumber & "&text=" & Text), 0, 0, 1

        GetWindowRect GetForegroundWindow, R
        SetCursorPos R.Left + (R.Right - R.Left) * 0.75, R.Bottom - 32
  
        mouse_event MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0
        mouse_event MOUSEEVENTF_LEFTUP, 0, 0, 0, 0
       
    Else
        ShellExecute mHwnd, StrPtr("Open"), StrPtr("https://web.whatsapp.com/send?phone=" & PhoneNumber & "&text=" & Text & "&app_absent=1&send=1"), 0, 0, 1
        Sleep Delay
    End If
    
    'para adjuntar una imagen
    If Not m_Images Is Nothing Then
        For i = 1 To m_Images.Count
            Clipboard.Clear
            Clipboard.SetData m_Images(i)
            Call keybd_event(vbKeyControl, 0, KEYEVENTF_KEYDOWN, 0)
            Call keybd_event(vbKeyV, 0, KEYEVENTF_KEYDOWN, 0)
        
            Call keybd_event(vbKeyControl, 0, KEYEVENTF_KEYUP, 0)
            Call keybd_event(vbKeyV, 0, KEYEVENTF_KEYUP, 0)
            Sleep 1000
        Next
    End If
    'para adjuntar un documento

    If Not m_Files Is Nothing Then
        If m_Files.Count > 0 Then
            SetTimer mHwnd, 0&, 500, AddressOf TimerProc
            MoveCursor
            SendMsg = InitDrag
            Sleep 1000
        End If
        
        If WhatsAppDesktop Then
'            MoveCursor
'            mouse_event MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0
'            mouse_event MOUSEEVENTF_LEFTUP, 0, 0, 0, 0
            SetForegroundWindow FindWindow(vbNullString, "WhatsApp")
        End If
    End If

    Sleep 1000
    'Send All
    Call keybd_event(vbKeyReturn, 0, KEYEVENTF_KEYDOWN, 0)
    Call keybd_event(vbKeyReturn, 0, KEYEVENTF_KEYUP, 0)
  
    For i = 0 To 4
        Call keybd_event(vbKeyEscape, 0, KEYEVENTF_KEYDOWN, 0)
        Call keybd_event(vbKeyEscape, 0, KEYEVENTF_KEYUP, 0)
        Sleep 500
    Next

    Sleep 1000
 
    
    'Cierra la pestaa, pero no es recomendable si hay adjuntos o mala conexion a internet
'    Call keybd_event(vbKeyControl, 0, KEYEVENTF_KEYDOWN, 0)
'    Call keybd_event(vbKeyW, 0, KEYEVENTF_KEYDOWN, 0)
'
'    Call keybd_event(vbKeyControl, 0, KEYEVENTF_KEYUP, 0)
'    Call keybd_event(vbKeyW, 0, KEYEVENTF_KEYUP, 0)
'     Sleep 1000

    BlockInput False
    If Not AnimateScreen Is Nothing Then
        Unload AnimateScreen
        ShowCursor True
    End If

    SetForegroundWindow mHwnd
End Function


Public Function ChrW2(ByVal CharCode As Long) As String
  Const POW10 As Long = 2 ^ 10
  If CharCode <= &HFFFF& Then ChrW2 = ChrW$(CharCode) Else _
                              ChrW2 = ChrW$(&HD800& + (CharCode And &HFFFF&) \ POW10) & _
                                      ChrW$(&HDC00& + (CharCode And (POW10 - 1)))
End Function


Private Sub SendKeys(sText As String, Optional bWait As Boolean)
    With CreateObject("WScript.Shell")
        .SendKeys sText, bWait
    End With
End Sub

Private Sub MoveCursor()
    Dim R As RECT
    GetWindowRect GetForegroundWindow, R
    SetCursorPos R.Left + (R.Right - R.Left) * 0.55, R.Top + (R.Bottom - R.Top) / 2
End Sub

Private Sub Sleep(Interval As Integer)
    Dim T As Single
    T = Timer + Interval / 1000
    Do While T > Timer
        DoEvents
    Loop
End Sub

'by Fafalone-----------------
Private Function GetPIDLFromPathW(sPath As String) As Long
   GetPIDLFromPathW = ILCreateFromPathW(StrPtr(sPath))
End Function

Private Function IID_IDataObject() As UUID
    '0000010e-0000-0000-C000-000000000046
    Static iid As UUID
     If (iid.Data1 = 0) Then Call DEFINE_UUID(iid, &H10E, CInt(&H0), CInt(&H0), &HC0, &H0, &H0, &H0, &H0, &H0, &H0, &H46)
      IID_IDataObject = iid
End Function
Private Function BHID_DataObject() As UUID
    '{0xB8C0BD9F, 0xED24, 0x455C, 0x83,0xE6, 0xD5,0x39,0x0C,0x4F,0xE8,0xC4}
    Static iid As UUID
     If (iid.Data1 = 0) Then Call DEFINE_UUID(iid, &HB8C0BD9F, &HED24, &H455C, &H83, &HE6, &HD5, &H39, &HC, &H4F, &HE8, &HC4)
     BHID_DataObject = iid
End Function

Private Sub DEFINE_UUID(Name As UUID, l As Long, w1 As Integer, w2 As Integer, B0 As Byte, b1 As Byte, b2 As Byte, B3 As Byte, b4 As Byte, b5 As Byte, b6 As Byte, b7 As Byte)
  With Name
    .Data1 = l
    .Data2 = w1
    .Data3 = w2
    .Data4(0) = B0
    .Data4(1) = b1
    .Data4(2) = b2
    .Data4(3) = B3
    .Data4(4) = b4
    .Data4(5) = b5
    .Data4(6) = b6
    .Data4(7) = b7
  End With
End Sub

Private Function InitDrag() As Boolean
    Dim hr0 As Long
    Dim iData As oleexp.IDataObject
    Dim psia As IShellItemArray
    Dim apidl() As Long
    Dim cpidl As Long
    Dim rpidl As Long
    Dim lRetDD As Long
    Dim i As Long
    Dim AllowedEffects As DROPEFFECTS
    
    If Not m_Files Is Nothing Then
        If m_Files.Count > 0 Then
            ReDim apidl(m_Files.Count - 1)
            For i = 1 To m_Files.Count
                apidl(i - 1) = GetPIDLFromPathW(m_Files(i))
            Next
        End If
    End If

    cpidl = UBound(apidl) + 1
    
    oleexp.SHCreateShellItemArrayFromIDLists cpidl, VarPtr(apidl(0)), psia
    If psia Is Nothing Then
        Debug.Print "Failed to create IShellItemArray"
        Exit Function
    End If
    
    psia.BindToHandler 0&, BHID_DataObject, IID_IDataObject, iData
    If iData Is Nothing Then
        Debug.Print "Failed to created IDataObject"
        Exit Function
    End If
                
    AllowedEffects = DROPEFFECT_COPY Or DROPEFFECT_MOVE Or DROPEFFECT_LINK
    
    hr0 = SHDoDragDrop(0&, ObjPtr(iData), 0, AllowedEffects, lRetDD) 'theoretically you can supply your own IDropSource implementation, but I never got it working
    
    Debug.Print "hr0=" & hr0 & ",lRet=" & lRetDD 'hr0 contains the HRESULT of the call, and lRetDD is the result of the operation, see the full DROPEFFECT description for all possible values
    
    InitDrag = lRetDD
    
    For i = 0 To UBound(apidl)
        Call CoTaskMemFree(apidl(i))
    Next i
    Set iData = Nothing

End Function
